/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FEFI                                                     */
/* Tabela : FERIFILI                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_FEFI'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_FEFI
GO

CREATE TRIGGER DTULTATU_FEFI
ON FERIFILI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'FERIFILI', CDFILIAL, 'CDFILIAL='  + CDFILIAL  + ';'+
                                             'DTFERIFILI='+ CONVERT(CHAR,DTFERIFILI,120)+ ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE FERIFILI
      SET DTULTATUFEFI = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(FERIFILI.CDFILIAL,0)   = ISNULL(INSERTED.CDFILIAL,0))
        AND (ISNULL(FERIFILI.DTFERIFILI,CONVERT(DATETIME,'31/12/1899')) = ISNULL(INSERTED.DTFERIFILI,CONVERT(DATETIME,'31/12/1899')));
   END;
END;
GO

UPDATE FERIFILI SET DTULTATUFEFI = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUFEFI IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUFEFI' and
            type = 'D')
   ALTER TABLE FERIFILI DROP CONSTRAINT DEFAULT_DTULTATUFEFI
GO

ALTER TABLE FERIFILI ADD CONSTRAINT DEFAULT_DTULTATUFEFI
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUFEFI
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_FEFI','4.11.194';
GO

