IF EXISTS(SELECT *
            FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_MENSCLIENTE' 
             AND TYPE   = 'TR'
             AND U.UID  = O.UID
             AND U.NAME = USER)

   DROP TRIGGER LOG_GER_MENSCLIENTE
GO

CREATE TRIGGER LOG_GER_MENSCLIENTE
ON MENSCLIENTE
FOR UPDATE, INSERT, DELETE
AS
BEGIN
   DECLARE @V_USUARIO      VARCHAR(40);
   DECLARE @V_TIPO         VARCHAR(01);
   DECLARE @V_TPMOVI       VARCHAR(01);
   DECLARE @V_ITPESQ       VARCHAR(40);
   DECLARE @V_DESC         VARCHAR(700);
   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DTOPER       DATETIME;

   /* ****INCIO DAS VARIVEIS DO C_MENSCLIENTE***** */
   DECLARE @V_NEW_CDCLIENTE       VARCHAR(21);
   DECLARE @V_NEW_NRMENSCLIENTE   VARCHAR(05);
   DECLARE @V_NEW_CDMENSAGEM      VARCHAR(03);
   DECLARE @V_NEW_IDENTRSAIDMENS  VARCHAR(01);
   DECLARE @V_NEW_DSMENSCLIENTE   VARCHAR(250);
   
   DECLARE @V_OLD_CDCLIENTE       VARCHAR(21);
   DECLARE @V_OLD_NRMENSCLIENTE   VARCHAR(05);
   DECLARE @V_OLD_CDMENSAGEM      VARCHAR(03);
   DECLARE @V_OLD_IDENTRSAIDMENS  VARCHAR(01);
   DECLARE @V_OLD_DSMENSCLIENTE   VARCHAR(250);
   /* ****FINAL DAS VARIVEIS DO C_MENSCLIENTE***** */

   SET @V_TIPO         = '0';
   SET @V_DESC         = '';

   DECLARE C_MENSCLIENTE CURSOR FOR
      SELECT 
         'D' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         DELETED.CDCLIENTE,
         DELETED.NRMENSCLIENTE,
         DELETED.CDMENSAGEM,
         DELETED.IDENTRSAIDMENS,
         DELETED.DSMENSCLIENTE
      FROM
         DELETED
      WHERE
         0 = (SELECT 
                 COUNT(*) 
              FROM 
                 INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.CDCLIENTE,
         INSERTED.NRMENSCLIENTE,
         INSERTED.CDMENSAGEM,
         INSERTED.IDENTRSAIDMENS,
         INSERTED.DSMENSCLIENTE,
         DELETED.CDCLIENTE,
         DELETED.NRMENSCLIENTE,
         DELETED.CDMENSAGEM,
         DELETED.IDENTRSAIDMENS,
         DELETED.DSMENSCLIENTE
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDCLIENTE = DELETED.CDCLIENTE

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDCLIENTE,
         INSERTED.NRMENSCLIENTE,
         INSERTED.CDMENSAGEM,
         INSERTED.IDENTRSAIDMENS,
         INSERTED.DSMENSCLIENTE,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT 
                 COUNT(*) 
              FROM 
                 DELETED)

   OPEN C_MENSCLIENTE;
   FETCH NEXT FROM C_MENSCLIENTE INTO @V_TIPO, 
                                      @V_NEW_CDCLIENTE,
                                      @V_NEW_NRMENSCLIENTE,
                                      @V_NEW_CDMENSAGEM,
                                      @V_NEW_IDENTRSAIDMENS,
                                      @V_NEW_DSMENSCLIENTE,
                                      @V_OLD_CDCLIENTE,
                                      @V_OLD_NRMENSCLIENTE,
                                      @V_OLD_CDMENSAGEM,
                                      @V_OLD_IDENTRSAIDMENS,
                                      @V_OLD_DSMENSCLIENTE;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      /* DELETE */
      IF @V_TIPO = 'D' BEGIN
         SET @V_TPMOVI       = '3';
         SET @V_ITPESQ       = @V_OLD_CDCLIENTE;
         
         IF @V_OLD_CDCLIENTE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdCliente=' + @V_OLD_CDCLIENTE;
         END;

         IF @V_OLD_NRMENSCLIENTE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrMensCliente=' + @V_OLD_NRMENSCLIENTE;
         END;

         IF @V_OLD_CDMENSAGEM IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdMensagem=' + @V_OLD_CDMENSAGEM;
         END;

         IF @V_OLD_IDENTRSAIDMENS IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdEntrSaidMens=' + @V_OLD_IDENTRSAIDMENS;
         END;

         IF @V_OLD_DSMENSCLIENTE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DsMensCliente=' + @V_OLD_DSMENSCLIENTE;
         END;
      END
      ELSE BEGIN
         /* UPDATE */
         IF @V_TIPO = 'U' BEGIN
            IF (ISNULL(@V_OLD_CDCLIENTE, '!')      <> ISNULL(@V_NEW_CDCLIENTE, '!'))      OR
               (ISNULL(@V_OLD_NRMENSCLIENTE, '!')  <> ISNULL(@V_NEW_NRMENSCLIENTE, '!'))  OR
               (ISNULL(@V_OLD_CDMENSAGEM, '!')     <> ISNULL(@V_NEW_CDMENSAGEM, '!'))     OR
               (ISNULL(@V_OLD_IDENTRSAIDMENS, '!') <> ISNULL(@V_NEW_IDENTRSAIDMENS, '!')) OR 
               (ISNULL(@V_OLD_DSMENSCLIENTE, '!')  <> ISNULL(@V_NEW_DSMENSCLIENTE, '!'))  
            BEGIN
               SET @V_TPMOVI       = '2';
               SET @V_ITPESQ       = @V_OLD_CDCLIENTE;
            END;
         END
         ELSE BEGIN
            /* INSERT */
            SET @V_TPMOVI        = '1';
            SET @V_ITPESQ        = @V_NEW_CDCLIENTE;
         END;

         IF ISNULL(@V_NEW_CDCLIENTE, '!') <> ISNULL(@V_OLD_CDCLIENTE, '!') BEGIN
            SET @V_DESC = @V_DESC + ' CdCliente=' + @V_NEW_CDCLIENTE;
         END;

         IF ISNULL(@V_NEW_NRMENSCLIENTE, '!') <> ISNULL(@V_OLD_NRMENSCLIENTE, '!') BEGIN
            SET @V_DESC = @V_DESC + ' NrMensCliente=' + @V_NEW_NRMENSCLIENTE;
         END;

         IF ISNULL(@V_NEW_CDMENSAGEM, '!') <> ISNULL(@V_OLD_CDMENSAGEM, '!') BEGIN
            SET @V_DESC = @V_DESC + ' CdMensagem=' + @V_NEW_CDMENSAGEM;
         END;

         IF ISNULL(@V_NEW_IDENTRSAIDMENS, '!') <> ISNULL(@V_OLD_IDENTRSAIDMENS, '!') BEGIN
            SET @V_DESC = @V_DESC + ' IdEntrSaidMens=' + @V_NEW_IDENTRSAIDMENS;
         END;

         IF ISNULL(@V_NEW_DSMENSCLIENTE, '!') <> ISNULL(@V_OLD_DSMENSCLIENTE, '!') BEGIN
            SET @V_DESC = @V_DESC + ' DsMensCliente=' + @V_NEW_DSMENSCLIENTE;
         END;
      END;

      IF @V_TPMOVI <> '0' BEGIN
         EXEC NMUSUARIO  @P_NMUSUARIO    = @V_USUARIO OUTPUT;
         EXEC WEBTUNNING @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                         @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                         @P_DSSERVERRDM  = @V_DSSERVERRDM  OUTPUT,
                         @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                         @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;
         SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,
                   DTOPERACAO,
                   NMRESPOPER,
                   IDTIPOOPER,
                   CDPESQITEM,
                   DSOPERACAO,
                   DSRDMUSUOPER,
                   DSENDUSUOPER,
                   DSNMUSUOPER,
                   DSMETUSUOPER,
                   CDORESPOPER)
               VALUES
                  ('MENSCLIENTE',
                   @V_DTOPER,
                   @V_USUARIO,
                   @V_TPMOVI,
                   @V_ITPESQ,
                   SUBSTRING(@V_DESC,1,700),
                   @V_DSSERVERRDM,
                   @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER);
            END;
         END;
      END;
      FETCH NEXT FROM C_MENSCLIENTE INTO @V_TIPO, 
                                         @V_NEW_CDCLIENTE,
                                         @V_NEW_NRMENSCLIENTE,
                                         @V_NEW_CDMENSAGEM,
                                         @V_NEW_IDENTRSAIDMENS,
                                         @V_NEW_DSMENSCLIENTE,
                                         @V_OLD_CDCLIENTE,
                                         @V_OLD_NRMENSCLIENTE,
                                         @V_OLD_CDMENSAGEM,
                                         @V_OLD_IDENTRSAIDMENS,
                                         @V_OLD_DSMENSCLIENTE;
   END;
   CLOSE C_MENSCLIENTE;
   DEALLOCATE C_MENSCLIENTE;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_MENSCLIENTE','6.00.xxx';
GO
